package net.pijcke.mazes.generation

import net.pijcke.mazes.rectangular.CellRectangularGrid
import net.pijcke.mazes.rectangular.CartesianPosition
import net.pijcke.mazes.rectangular.RectangularGridWalker

object BinaryTree {

    fun on(grid: CellRectangularGrid, walker: RectangularGridWalker) {
        for (p in walker.makeSequence(grid)) {
            possibleLinkedPositions(grid, p, walker).randomOrNull()?.let {
                grid.link(p, it)
            }
        }
    }

    private fun possibleLinkedPositions(grid: CellRectangularGrid, position: CartesianPosition, walker: RectangularGridWalker): List<CartesianPosition> {
        return walker.unitVectors().map { it(position) }.filter { grid.isWithinBounds(it) }
    }

}
