package net.pijcke.mazes.grid.graph

import net.pijcke.mazes.grid.Grid
import net.pijcke.mazes.grid.Position
import java.util.*

abstract class GraphGrid<P: Position<P>>(private val nodes: Collection<P>, edges: MutableCollection<Edge<P>>): Grid<P> {

    private val edges = TreeSet(edges)

    override fun getPositions() = nodes

    override fun link(position1: P, position2: P) {
        edges.add(Edge(position2, position1))
        edges.add(Edge(position1, position2))
    }

    override fun linked(position1: P, position2: P): Boolean {
        return edges.contains(Edge(position1, position2))
    }

}