package net.pijcke.mazes.rectangular

import net.pijcke.mazes.grid.Position

data class CartesianPosition(val x: Int, val y: Int) : Position<CartesianPosition> {

    override fun neighbours() = listOf(south(), north(), west(), east())

    fun south() = CartesianPosition(x, y - 1)
    fun north() = CartesianPosition(x, y + 1)
    fun west() = CartesianPosition(x - 1, y)
    fun east() = CartesianPosition(x + 1, y)

    override fun compareTo(other: CartesianPosition): Int {
        return Comparator.comparing(CartesianPosition::x)
            .thenComparing(CartesianPosition::y)
            .compare(this, other)
    }

}