package net.pijcke.mazes.rectangular

class RectangularGridPrinter(private val grid: RectangularGrid) {

    fun print() {
        println("+---".repeat(grid.width) + "+")
        for (y in grid.height - 1 downTo 0) {

            (0 ..< grid.width)
                .map { CartesianPosition (it, y) }
                .map { "   " + if (grid.linked(it, it.east())) " " else "|" }
                .joinToString("", "|", "")
                .let { println(it) }

            (0 ..< grid.width)
                .map { CartesianPosition (it, y) }
                .map { if (grid.linked(it, it.south())) "   " else "---" }
                .joinToString("+", "+", "+")
                .let { println(it) }
        }
    }

}